NICKNAME   = "Frodo"
MYPICTURE  = "me.png"
FILEDIR    = "/tmp/cerebro/" # Always use trailing "/" !!!
ICONDIR    = "/usr/share/cerebro/gui/"

########################################################################
########################################################################
#        You should NOT have to edit anything below this line          #
########################################################################
########################################################################

from os.path import expanduser
FILEDIR = expanduser(FILEDIR)
ICONDIR = expanduser(ICONDIR)

from struct import pack, unpack
try:
	from IPython.ultraTB import FormattedTB
	trace = FormattedTB(mode='Verbose', color_scheme='NoColor', call_pdb=0)
except:
	import traceback
	trace = traceback.print_exc

import sys, time
START = time.time()
sys.excepthook = trace

PERIOD         = 3

ACK_FRAME      = "0"
FILE_FRAME     = "1"
REQ_FILE_FRAME = "2"
PRESENCE_FRAME = "3"

ETH_DAT_TELEPORTER = 0x7600
ETH_REQ_TELEPORTER = 0x7601
ETH_PRESENCE       = 0x7602

ETH_DAT_TELEPORTER_HEX = pack("!H", ETH_DAT_TELEPORTER)
ETH_REQ_TELEPORTER_HEX = pack("!H", ETH_REQ_TELEPORTER)
ETH_PRESENCE_HEX       = pack("!H", ETH_PRESENCE)

USERINFO_PORT = '\x00\x00'
FILE_PORT     = '\x02\x00'
STATS_PORT    = '15'
CHATTYPE      = '\x01\x01'
PICTYPE       = '\x01\x99'


def bin2mac(bin, all=True):
	if all:
		m = bin      # return all the bytes
		d = ''
	else:
		m = bin[-3:] # get the last three bytes
		d = ':'
		
	return d.join(["%02X" % ord(c) for c in m])

def pout(*args):
	if len(args) < 2 or not type(args[0]) is int:
		print "POUT: wrong call to pout:", args
		raise
	
	debug_level = args[0]
	if debug_level > 10:
		if len(args) == 2:
			string = [args[1]]
		else:
			string = args[1:]
		
		print ' '.join([str(el) for el in string])
		
		
class Stats:
	def __init__(self):
		self.arrivals = {}
		self.presence_overhead = []
		
	def save(self, filename):
		f = open(FILEDIR+filename, 'w')
		f.write("%f\n" % START)
		for a in self.arrivals:
			f.write( "%s %s\n" % (a, self.arrivals[a]) )
		f.write('\n')
		for line in self.presence_overhead:
			f.write( "%d %f\n" % (line[0], line[1]) )
		f.close()
		