#!/usr/bin/python

from random import random
from urllib import url2pathname
from os.path import isdir
import json
from cerebro.graph import Graph

DOC_ROOT = "/usr/share/cerebro/gui/"

class MyHandler:
	def __init__(self, connection, client_address, server, guiCallback, matrix, allnodes, edges, edge, extra_nodes, nodn):
		self.clback   = guiCallback
		self.graph    = Graph(20)
		self.matrix   = matrix
		self.allnodes = allnodes
		self.extra_nodes = extra_nodes
		self.edges    = edges
		self.edge     = edge
		self.nodn     = nodn
		
		self.do_GET(connection)
	
	def position(self):
		#convert -background transparent xo.svg xo.png
		
		#for i in xrange(len(self.matrix)):
			#print "matrix:", self.allnodes[i], self.matrix[i]
		
		# Extract cartesian positions from Adjacency Matrix
		layout = self.graph.get_layout(self.matrix, self.edge)
		
		#for i in xrange(len(layout)):
			#print "layout:", self.allnodes[i], layout[i]._x, layout[i]._y
		
		nodes = []
		#print "mst.node", mst.node
		for i in xrange(len(self.allnodes)):
			profile = {}
			profile['id']   = self.allnodes[i]
			profile['x']    = layout[i]._x
			profile['y']    = layout[i]._y
			nodes.append( profile )
			
		dic = {}
		dic['nodes'] = nodes
		dic['edges'] = self.edges
		dic['extra_nodes'] = self.extra_nodes
		
		return json.write( dic )
		
	def do_GET(self, connection):
		url  = connection.recv(10000).split("\r\n")[0]
		#buf  = "<html>asdf<br>"
		#buf += url+"<br>"
		url = url[4:-9]
		#buf += url+"<br>"
		
		
		#connection.send(buf)
		
		filetype = url.split('.')[-1]
		
		#if filetype == "svg" or filetype == "xhtml":
			#connection.send("Content-type", "image/svg+xml")
		#elif filetype == "css":
			#s.send_header("Content-type", "text/css")
		#else:
			#s.send_header("Content-type", "text/html")
			
		#s.end_headers()

		var = {}
		if url[:13] == "/get.allnodes":
			self.edge = int( url.split('?')[1] )
			jsn = self.position()
			connection.send( jsn )
			
		elif url[:11] == "/get.update":
			self.edge = int( url.split('?')[1] )
			jsn = self.position()
			connection.send( jsn )
			
		elif url[:10] == "/set.scale":
			scale = int( url.split('?')[1] )
			self.clback("scale", scale)
			
		elif url[:9] == "/set.edge":
			edge = int( url.split('?')[1] )
			self.clback("edge", edge)
			
		elif url[:14] == "/set.gui_limit":
			gui_limit = int( url.split('?')[1] )
			self.clback("gui_limit", gui_limit)
			
		elif url[:29] == "/js/greybox/loader_frame.html":
			file = open(DOC_ROOT + url[1:29], 'r').read()
			connection.send( file )
			
		elif url[:5] == "/upda":
			variables = url.split("?")[1].split("&")
			for v in variables:
				print "dealing with", v, len(v)
				if v:
					field = v.split("=")
					var[field[0]] = field[1]
				
			connection.send( url2pathname(var['content']) )
			
		else:
			docpath = DOC_ROOT + url[1:]
			if isdir( docpath ):
				docpath += "index.html"
			try:
				file = open(docpath, 'r').read()
			except:
				if url[1:3] == "xo" and url[-4:] == ".png":
					if url[3:-4] == ''.join([c for c in self.allnodes[0].split(":")]):
						file = open(DOC_ROOT+"xo.png", 'r').read()
					else:
						file = open(DOC_ROOT+"xo.png", 'r').read()
				else:
					raise
				
			connection.send( file )


if __name__ == '__main__':
	server_class = BaseHTTPServer.HTTPServer
	httpd = server_class((HOST_NAME, PORT_NUMBER), MyHandler)
	print time.asctime(), "Server Starts - %s:%s" % (HOST_NAME, PORT_NUMBER)
	try:
		httpd.serve_forever()
	except KeyboardInterrupt:
		pass
	httpd.server_close()
	print time.asctime(), "Server Stops - %s:%s" % (HOST_NAME, PORT_NUMBER)
